/****************************/
/*			 Items 			*/
/****************************/
#include <stdio.h>
#include <View.h>
#include <Control.h>
#include "NetCountCalendarDatas.h"

#include <iostream.h>

/**** class desitems qui composent les données ****/
NetCountCalendarItem::NetCountCalendarItem(void)
: BListItem()
{
	rgb_color	color0 = {0,0,0,255};
	
	_colorcase = color0;
	_valueprice = 1.0;
	_nameprice = new BString("No Name");
}

NetCountCalendarItem::NetCountCalendarItem(rgb_color itemcolor,const char *itemname, float itemprice)
: BListItem()
{
	_colorcase = itemcolor;
	_valueprice = itemprice;
	_nameprice = new BString(itemname);
}

NetCountCalendarItem::~NetCountCalendarItem(void)
{
	delete _nameprice;
}

void NetCountCalendarItem::DrawItem(BView *owner,BRect frame,bool complete)
{
	static char	buffer[50];
	BRect		ItemFrame;
	rgb_color	OldColor;
	rgb_color	OldLowColor;
		
	ItemFrame.left = frame.left + 15;
	ItemFrame.top = frame.top + 1;
	ItemFrame.bottom = frame.bottom - 1;
	ItemFrame.right = ItemFrame.bottom - ItemFrame.top + 15;

	OldColor = owner->HighColor();
	OldLowColor = owner->LowColor();
	
	if(IsSelected())
		owner->SetHighColor(200,200,255,255);
	else
		owner->SetHighColor(255,255,255,255);	
	owner->SetLowColor(owner->HighColor());	
	owner->FillRect(frame);
	
	owner->SetHighColor(_colorcase);
	owner->FillRect(ItemFrame);

	owner->SetHighColor(220,220,220,255);
	owner->StrokeLine(BPoint(ItemFrame.left,ItemFrame.top),BPoint(ItemFrame.right,ItemFrame.top));
	owner->StrokeLine(BPoint(ItemFrame.left,ItemFrame.top),BPoint(ItemFrame.left,ItemFrame.bottom));
	owner->SetHighColor(110,110,110,255);
	owner->StrokeLine(BPoint(ItemFrame.right,ItemFrame.top),BPoint(ItemFrame.right,ItemFrame.bottom));
	owner->StrokeLine(BPoint(ItemFrame.left,ItemFrame.bottom),BPoint(ItemFrame.right,ItemFrame.bottom));

	owner->SetHighColor(0,0,0,255);
	owner->DrawString(_nameprice->String(),BPoint(frame.left+50, frame.bottom - 2));
	owner->SetHighColor(0,0,255);
	sprintf(buffer,"%.2f",_valueprice);
	owner->DrawString(buffer,BPoint(frame.left+318, frame.bottom - 2));

	owner->SetHighColor(OldColor);
	owner->SetLowColor(OldLowColor);
}

/**** items jours feries ****/
BlankDayItem::BlankDayItem(void)
{
}

BlankDayItem::BlankDayItem(int32 day, int32 month,const char* name, int32 index,rgb_color color)
{
	_day = day;
	_month = month;
	_indexPrice = index;
	_name.SetTo(name);
	_colorCase = color;
}

BlankDayItem::~BlankDayItem(void)
{
}

void BlankDayItem::DrawItem(BView *owner,BRect frame,bool complete)
{
	static char	buffer[50];
	BRect		ItemFrame;
	rgb_color	OldColor;
	rgb_color	OldLowColor;
	rgb_color	color;
		
	ItemFrame.left = frame.left + 360;
	ItemFrame.top = frame.top + 1;
	ItemFrame.bottom = frame.bottom - 1;
	ItemFrame.right = ItemFrame.bottom - ItemFrame.top + 360;

	OldColor = owner->HighColor();
	OldLowColor = owner->LowColor();
	
	if(IsSelected())
		owner->SetHighColor(200,200,255,255);
	else
		owner->SetHighColor(255,255,255,255);	
	owner->SetLowColor(owner->HighColor());	
	owner->FillRect(frame);
	
	owner->SetHighColor(0,0,255);
	sprintf(buffer,"%2ld",_day);
	owner->DrawString(buffer,BPoint(frame.left+18, frame.bottom - 2));
	sprintf(buffer,"%2ld",_month);
	owner->DrawString(buffer,BPoint(frame.left+67, frame.bottom - 2));
	owner->SetHighColor(0,0,0,255);
	owner->DrawString(_name.String(),BPoint(frame.left+105, frame.bottom - 2));

	owner->SetHighColor(_colorCase);
	owner->FillRect(ItemFrame);

	owner->BeginLineArray(4);
	owner->SetHighColor(220,220,220,255);
	color = owner->HighColor();
	owner->AddLine(BPoint(ItemFrame.left,ItemFrame.top),BPoint(ItemFrame.right,ItemFrame.top),color);
	owner->AddLine(BPoint(ItemFrame.left,ItemFrame.top),BPoint(ItemFrame.left,ItemFrame.bottom),color);
	owner->SetHighColor(110,110,110,255);
	color = owner->HighColor();
	owner->AddLine(BPoint(ItemFrame.right,ItemFrame.top),BPoint(ItemFrame.right,ItemFrame.bottom),color);
	owner->AddLine(BPoint(ItemFrame.left,ItemFrame.bottom),BPoint(ItemFrame.right,ItemFrame.bottom),color);
	owner->EndLineArray();	

	owner->SetHighColor(OldColor);
	owner->SetLowColor(OldLowColor);
}

/**** class des données ****/
NetCountCalendarDatas::NetCountCalendarDatas()
{
	rgb_color	tarifbleu={0,0,255,255};
	rgb_color	tarifrouge={255,0,0,255};

	_dataslist = new int32[LENGTH_DATA_LIST];//[24][7];
	memset(_dataslist,0,LENGTH_DATA_LIST*sizeof(int32));

	_priceslist = new BList();
	AddNetItem(tarifbleu,"France Telecom Tarif Bleu",8.40);	
	AddNetItem(tarifrouge,"France Telecom Tarif Rouge",16.80);
	_dayslist = new BString("SunMonTueWedThuFriSat");
	for(int32 i=8;i<19;i++)
		SetRowTo(i,1);
	SetColTo(0,0);
	SetColTo(6,0);
		
	// pixed price
	_usefixedprice = false;
	SetNameForFixedPrice("Integrale Wanadoo 10h");
	_fixedprice = 79.00;
	_timeforfixedprice = 10;
	_fixedplusprice = 18.00;
	_plusUseCalendar=false;
	_startDay=1;
	_startDayType = B_CONTROL_OFF;
	_entireMinute = B_CONTROL_OFF;
	
	// connection cost
	_useconnectioncost = true;
	SetNameforCostConnection("Cout de connection France Telecom");
	_priceofconnect = 0.74;
	_timeforpriceofconnect = 180;
	_itemchanged = false;

	// set the frame for settings window
	_winframe.Set(272,160,690,400);
	
	// jour feries
	_blankDay = new BList();
	_lastDayChange = 255;
	_isBlankDay = false;
	_currentIndex = -1;
	
}

NetCountCalendarDatas::~NetCountCalendarDatas()
{
	delete []_dataslist;
	delete _dayslist;
	EraseItem();
	delete _priceslist;
	delete _blankDay;
}

void NetCountCalendarDatas::EraseItem()
{
	int32	numberItem;
	
	numberItem = _priceslist->CountItems();
	for(int32 i=0;i<numberItem;i++)
		delete (NetCountCalendarItem *)_priceslist->RemoveItem((int32)0);

	numberItem = _blankDay->CountItems();
	for(int32 i=0;i<numberItem;i++)
		delete (BlankDayItem *)_blankDay->RemoveItem((int32)0);
}

void NetCountCalendarDatas::AddNetItem(rgb_color itemcolor,const char *itemname, float itemprice)
{
	_priceslist->AddItem(new NetCountCalendarItem(itemcolor,itemname,itemprice));
}

void NetCountCalendarDatas::AddBlankItem(int32 day,int32 month,const char *name,int32 index,rgb_color color)
{
	_blankDay->AddItem(new BlankDayItem(day,month,name,index,color));
}

/**** Set a row of calendar to a value ****/
void NetCountCalendarDatas::SetRowTo(int32 row,int32 value)
{
	int	posdepart;
	
	posdepart = row * 7;
	for(int i=0;i<7;i++)
		_dataslist[posdepart+i] = value;
}

/**** Set a column of calendar to a value ****/
void NetCountCalendarDatas::SetColTo(int32 col,int32 value)
{
	int	posdepart;
	
	posdepart = col;
	for(int i=0;i<24;i++)
		_dataslist[posdepart+i*7] = value;
}

/**** Save preferences into a BMessage ****/
BMessage NetCountCalendarDatas::SaveDatas()
{
	BMessage				prefdatas;
	NetCountCalendarItem	*priceitem;
	BlankDayItem			*blankitem;
	int32					number;
	rgb_color				itemcolor;


	prefdatas.AddRect(WIN_PREF_CALENDAR,_winframe);
	// fied price
	prefdatas.AddString(NAME_OF_FIXED_PRICE,_namefixedprice);
	prefdatas.AddBool(USE_FIXED_PRICE,_usefixedprice);
	prefdatas.AddFloat(PRICE_OF_FIXED_PRICE,_fixedprice);
	prefdatas.AddInt32(TIME_OF_FIXED_PRICE,_timeforfixedprice);
	prefdatas.AddFloat(PLUS_PRICE_OF_FIXED_PRICE,_fixedplusprice);
	prefdatas.AddBool(USE_CALENDAR_PLUS,_plusUseCalendar);
	prefdatas.AddInt32(START_DAY_FIXED,_startDay);
	prefdatas.AddInt32(START_DAY_TYPE,_startDayType);
	prefdatas.AddInt32(ENTIRE_MINUTE,_entireMinute);
	// connection cost
	prefdatas.AddString(NAME_OF_CONNECT,_nameconnectioncost);
	prefdatas.AddBool(USE_PRICE_OF_CONNECT,_useconnectioncost);
	prefdatas.AddFloat(PRICE_OF_CONNECT,_priceofconnect);
	prefdatas.AddInt32(TIME_OF_CONNECT,_timeforpriceofconnect);

	for(int i=0;i<LENGTH_DATA_LIST;i++)
		prefdatas.AddInt32(DATA_LIST,_dataslist[i]);
	
	number =_priceslist->CountItems();
	prefdatas.AddInt32(ITEM_NUMBER,number);
	for(int i=0;i<number;i++)
	{
		priceitem = (NetCountCalendarItem*)_priceslist->ItemAt(i);
		itemcolor = priceitem->ItemColor();
		prefdatas.AddData(ITEM_COLOR,B_RGB_COLOR_TYPE,&itemcolor,sizeof(itemcolor));
		prefdatas.AddString(ITEM_PRICE_NAME,(priceitem->ItemName()).String());		
		prefdatas.AddFloat(ITEM_PRICE,priceitem->ItemPrice());	
	}
	
	number =_blankDay->CountItems();
	prefdatas.AddInt32(BLANK_ITEM_NUMBER,number);
	for(int i=0;i<number;i++)
	{
		blankitem = (BlankDayItem*)_blankDay->ItemAt(i);
		prefdatas.AddString(BLANK_ITEM_NAME,(blankitem->ItemName()).String());		
		prefdatas.AddInt32(BLANK_ITEM_DAY,blankitem->ItemDay());
		prefdatas.AddInt32(BLANK_ITEM_MONTH,blankitem->ItemMonth());
		prefdatas.AddInt32(BLANK_ITEM_INDEX,blankitem->ItemIndex());	
	}
	
	return 	prefdatas;
}

/**** Load preferences from a BMessage ****/
void NetCountCalendarDatas::LoadDatas(BMessage *prefdatas)
{
	const char				*name;
	int32					number;
	rgb_color				*color;
	float					itemprice;
	ssize_t					tailleobjet;
	rgb_color				blankColor;
	int32					day;
	int32					month;
	int32					index;

	if(prefdatas->FindRect(WIN_PREF_CALENDAR,&_winframe) != B_OK)
		_winframe.Set(272,160,690,400);

	// fied price
	if(prefdatas->FindBool(USE_FIXED_PRICE,&_usefixedprice) != B_OK)
		_usefixedprice = false;
	if(prefdatas->FindString(NAME_OF_FIXED_PRICE,&_namefixedprice) != B_OK)
		_namefixedprice.SetTo("Integrale Wanadoo 10h");
	if(prefdatas->FindFloat(PRICE_OF_FIXED_PRICE,&_fixedprice) != B_OK)
		_fixedprice = 79.00;
	if(prefdatas->FindInt32(TIME_OF_FIXED_PRICE,&_timeforfixedprice) != B_OK)
		_timeforfixedprice = 10;
	if(prefdatas->FindFloat(PLUS_PRICE_OF_FIXED_PRICE,&_fixedplusprice) != B_OK)
		_fixedplusprice = 18.00;
	if(prefdatas->FindBool(USE_CALENDAR_PLUS,&_plusUseCalendar) != B_OK)
		_plusUseCalendar=false;
	if(prefdatas->FindInt32(START_DAY_FIXED,&_startDay) != B_OK)
		_startDay=1;
	if(prefdatas->FindInt32(START_DAY_TYPE,&_startDayType) != B_OK)
		_startDayType = B_CONTROL_OFF;
	if(prefdatas->FindInt32(ENTIRE_MINUTE,&_entireMinute) != B_OK)
		_entireMinute = B_CONTROL_OFF;

	// connection cost
	if(prefdatas->FindBool(USE_PRICE_OF_CONNECT,&_useconnectioncost) != B_OK)
		_useconnectioncost = true;
	if(prefdatas->FindString(NAME_OF_CONNECT,&_nameconnectioncost) != B_OK)
		_nameconnectioncost.SetTo("Cout de connection France Telecom");
	if(prefdatas->FindFloat(PRICE_OF_CONNECT,&_priceofconnect) != B_OK)
		_priceofconnect = 0.74;
	if(prefdatas->FindInt32(TIME_OF_CONNECT,&_timeforpriceofconnect) != B_OK)
		_timeforpriceofconnect = 180;

	for(int i=0;i<LENGTH_DATA_LIST;i++)
		prefdatas->FindInt32(DATA_LIST,i,&(_dataslist[i]));

	EraseItem();
	
	// connections items
	prefdatas->FindInt32(ITEM_NUMBER,&number);
	for(int32 i=0;i<number;i++)
	{
		prefdatas->FindData(ITEM_COLOR,B_RGB_COLOR_TYPE,i,(const void **)&color,&tailleobjet);
		prefdatas->FindString(ITEM_PRICE_NAME,i,&name);
		prefdatas->FindFloat(ITEM_PRICE,i,&itemprice);		
		AddNetItem(*color,name,itemprice);
	}
	
	// blank days
	prefdatas->FindInt32(BLANK_ITEM_NUMBER,&number);
	for(int i=0;i<number;i++)
	{
		prefdatas->FindString(BLANK_ITEM_NAME,i,&name);		
		prefdatas->FindInt32(BLANK_ITEM_DAY,i,&day);
		prefdatas->FindInt32(BLANK_ITEM_MONTH,i,&month);
		prefdatas->FindInt32(BLANK_ITEM_INDEX,i,&index);	
		blankColor = ((NetCountCalendarItem*)(_priceslist->ItemAt(index)))->ItemColor();
		AddBlankItem(day,month,name,index,blankColor);
	}

}

/**** Verify if an item is used in the calendar ****/
bool NetCountCalendarDatas::IsUsed(int32 index)
{
	for (int i=0;i<64;i++)
		if (_dataslist[i] == index)
			return true;

	return false;
}

/**** Return true if changed something on item of prices ****/
/**** and fix the boolean as value false ****/
bool NetCountCalendarDatas::ListIsChanged()
{
	_itemchanged = false;
	
	return !_itemchanged;
}

float NetCountCalendarDatas::NetItemPrice(tm &dateTime)
{
	int32		tabindex;
	
	tabindex = IsBlankDay(dateTime);
	return ((NetCountCalendarItem*)(_priceslist->ItemAt(tabindex)))->ItemPrice();
}

rgb_color NetCountCalendarDatas::NetItemColor(tm &dateTime)
{
	int32		tabindex;
	
	tabindex = IsBlankDay(dateTime);
	return ((NetCountCalendarItem*)(_priceslist->ItemAt(tabindex)))->ItemColor();
}

int32 NetCountCalendarDatas::IsBlankDay(tm &dateTime)
{
	int32		tabindex;

	// day changed
	if(dateTime.tm_wday != _lastDayChange)
	{
		int32			blankDayNumber;
		BlankDayItem	*dayItem;
		
		_isBlankDay = false;
		blankDayNumber = _blankDay->CountItems();
		for(int32 i=0;i<blankDayNumber;i++)
		{
			dayItem = (BlankDayItem *)_blankDay->ItemAt(i);
			if(dateTime.tm_mday == dayItem->ItemDay() && dateTime.tm_mon == (dayItem->ItemMonth()-1))
			{
				_isBlankDay = true;
				_currentIndex = dayItem->ItemIndex();
				break;
			}
		}
	}
	
	if(!_isBlankDay)
	{
		tabindex = dateTime.tm_hour * 7 + dateTime.tm_wday;
		return _dataslist[tabindex];
	}
	else
		return _currentIndex;
}