#include <Roster.h>
#include "CLaunchNetPositiveView.h"

const	rgb_color		C_BLACK_COLOR	= {0,0,0,255};
const	rgb_color		C_BLUE_COLOR	= {100,100,255,255};

CLaunchNetPositiveView::CLaunchNetPositiveView(BRect frame, const char *name, const char *text, const char* URL)
: BControl(frame,name,"CLaunchNetPositiveView",NULL,B_FOLLOW_NONE,B_WILL_DRAW)
{
	_URL.SetTo(URL);
	_text.SetTo(text);
	_entered = false;
	
	SetViewColor(219,219,219);
	SetFontSize(10.0);
}

CLaunchNetPositiveView::~CLaunchNetPositiveView()
{
}

void CLaunchNetPositiveView::MouseDown(BPoint point)
{
	char	*url;

	url = (char *)_URL.String();
	be_roster->Launch(NET_POSITIVE_SIGN, 1, &url);
}

void CLaunchNetPositiveView::MouseMoved(BPoint point, uint32 transit,const BMessage *message)
{
	switch(transit)
	{
		case B_ENTERED_VIEW:
			_entered = true;
			Invalidate();
			break;
		case B_EXITED_VIEW:
			_entered = false;
			Invalidate();
			break;
		case B_INSIDE_VIEW:
			if(!_entered)
				Invalidate();
	}
}

void CLaunchNetPositiveView::Draw(BRect frame)
{
	rgb_color	oldcolor;
	rgb_color	oldlowcolor;
	rgb_color	textColor;
	
	oldcolor = HighColor();
	oldlowcolor = LowColor();

	SetLowColor(ViewColor());
	textColor = C_BLACK_COLOR;
	if(_entered)
		textColor = C_BLUE_COLOR;

	SetHighColor(textColor);
	DrawString(_text.String(),BPoint(0,10));

	SetLowColor(oldlowcolor);
	SetHighColor(oldcolor);
}
