#ifndef HISTORY_ITEM_H
#define HISTORY_ITEM_H

#include <time.h>
#include <ListItem.h>

const	int32 DETAILS	= 1;
const	int32 PER_MONTH = 2; 

class HistoryList : public BListItem
{
protected:
	int32	_connection;
	tm		_starttime;
	int32	_duringtime;
	float	_money;
	int32	_drawingmode;
	bool	_fixedprice;

public:
	HistoryList(int32,tm *,int32,float,int32 = DETAILS,bool = false);
	HistoryList(HistoryList&);
	virtual ~HistoryList();
	virtual void DrawItem(BView *owner,BRect frame,bool complete = false);
	
	inline void		SetNConnect(int32 value)	{ _connection = value; }
	inline void		SetFixedPrice(bool value)	{ _fixedprice = value; }
	
	inline int32 	Connection()	{ return _connection; }
	inline tm 		Start()			{ return _starttime; }
	inline int32	During()		{ return _duringtime; }
	inline float 	Price()			{ return _money; }
	inline bool		IsFixedPrice()	{ return _fixedprice; }
};

#endif