#ifndef PREFALLVIEWS_H
#define PREFALLVIEWS_H
/*****************************************/
/* Views for Window application settings */
/*****************************************/

#include <View.h>
#include <CheckBox.h>
#include <RadioButton.h>
#include <Button.h>
#include <Box.h>
#include <TextControl.h>
#include <TextView.h>
#include <FilePanel.h>
#include <MenuField.h>
#include "PTabView.h"
#include "CColorLabel.h"

class CounterApp;

// view for Application settings
const	uint32		U_VIEW_DESKBAR_MSG			= 'Uvdm';
const	uint32		U_MINIMIZE_AT_START_MSG		= 'Umas';
const	uint32		U_DISPLAY_TYPE_MSG			= 'Udtm';
const	uint32		U_PULSE_RATE_MSG			= 'Uprm';
const	uint32		U_SAVE_END_MSG				= 'Usae';

class ApplicationSettingView : public BView
{
protected:
	BBox					*_applicationBox;
	BCheckBox				*_viewDeskbar;
	BCheckBox				*_minimizeAtStart;
	BCheckBox				*_displayType;
	BCheckBox				*_pulseRate;
	BCheckBox				*_saveAtEnd;
	// acces to be_app
	CounterApp		*_app;
	
public:
	ApplicationSettingView(BRect);
	virtual ~ApplicationSettingView(void);
	virtual void MessageReceived(BMessage* msg);
	virtual void AttachedToWindow(void);

private:
	void Refresh();
};

// view for graphic settings
const	uint32		U_CHNANGE_TEXT_MSG		= 'Uctm';
const	uint32		U_CHNANGE_BACK_MSG		= 'Ucbm';
const	uint32		U_ENGLICH_RADIO_MSG		= 'Uerm';
const	uint32		U_FRENCH_RADIO_MSG		= 'Ufrm';
const	uint32		U_GERMAN_RADIO_MSG		= 'Ugrm';
const	uint32		U_ITALIEN_RADIO_MSG		= 'Uirm';

class DisplaySettingView : public BView
{
protected:
	BTextView				*_exemple;
	BBox					*_colorsBox;
	CColorLabel				*_colorText;
	CColorLabel				*_colorView;
	BBox					*_langageBox;
	BRadioButton			*_englichRadio;
	BRadioButton			*_frenchRadio;
	BRadioButton			*_germanRadio;
	BRadioButton			*_italienRadio;
	// acces to be_app
	CounterApp		*_app;
	
public:
	DisplaySettingView(BRect);
	virtual ~DisplaySettingView(void);
	virtual void MessageReceived(BMessage* msg);
	virtual void AttachedToWindow(void);

private:
	void Refresh();
};

// view for history setting
const	uint32		U_ADD_CHECK_MSG			= 'Uacm';
const	uint32		U_REMOVE_CHECK_MSG		= 'Urmm';
const	uint32		U_CHNANGE_FIXED_MSG		= 'Ucfm';
const	uint32		U_CHNANGE_STANDARD_MSG	= 'Ucsm';
const	uint32		U_CHNANGE_DATE_MSG		= 'Ucdm';
const	uint32		U_CHNANGE_TIME_MSG		= 'Uctm';
const	uint32		U_CHNANGE_PRICE_MSG		= 'Ucpm';

class HistorySettingView : public BView
{
protected:
	BBox					*_buttonsBox;
	BCheckBox				*_addCheck;
	BCheckBox				*_removeCheck;
	BBox					*_colorsBox;
	CColorLabel				*_colorStandard;
	CColorLabel				*_colorFixed;
	CColorLabel				*_colorDate;
	CColorLabel				*_colorTime;
	CColorLabel				*_colorPrice;
	// acces to be_app
	CounterApp		*_app;
	
public:
	HistorySettingView(BRect);
	virtual ~HistorySettingView(void);
	virtual void MessageReceived(BMessage* msg);
	virtual void AttachedToWindow(void);

private:
	void Refresh();
};

// View for old versions
const	uint32		U_IMPORT_MSG			= 'Uimm';
const	uint32		U_EXPORT_MSG			= 'Uexm';
const	uint32		U_ERASE_IMPORT_MSG		= 'Ueim';
const	uint32		U_FORMAT_VERSION_MSG	= 'Ufvm';
const	uint32		U_RECALCUL_TIME_MSG		= 'Urtm';
const	uint32		U_PANEL_IMPORT_MSG		= 'Upim';
const	uint32		U_PANEL_EXPORT_MSG		= 'Upem';
// message for delimiter MenuField
const	uint32		U_MENU_DEFAULT			= 'Umdd';
const	uint32		U_MENU_COMMA			= 'Umcd';
const	uint32		U_MENU_TABULATION		= 'Umtd';

class OldSettingView : public BView
{
protected:
	BBox					*_optionsBox;
	BCheckBox				*_eraseConnections;
	BCheckBox				*_formatExport;
	BCheckBox				*_recalculTime;
	BBox					*_impExpBox;
	BButton					*_import;
	BButton					*_export;
	BTextControl			*_pathinfo;
	BFilePanel				*_panelImport;
	BFilePanel				*_panelExport;
	BMenuField				*_delimiter;
	// acces to be_app
	CounterApp		*_app;
	
public:
	OldSettingView(BRect);
	virtual ~OldSettingView(void);
	virtual void MessageReceived(BMessage* msg);
	virtual void AttachedToWindow(void);

private:
	void Refresh();
};

// View for backup
const	uint32		U_USE_BACKUP_MSG		= 'Uubm';
const	uint32		U_PANEL_PATH_MSG		= 'Uppm';
// message for backup interval
const	uint32		U_MENU_28DAYS			= 'U28d';
const	uint32		U_MENU_14DAYS			= 'U14d';
const	uint32		U_MENU_7DAYS			= 'U7da';
const	uint32		U_MENU_DAYS				= 'Uday';

class BackupSettingView : public BView
{
protected:
	BBox					*_optionsBox;
	BCheckBox				*_useBackup;
/*	BCheckBox				*_formatExport;
	BCheckBox				*_recalculTime;
	BBox					*_impExpBox;
	BButton					*_import;
	BButton					*_export;
	BTextControl			*_pathinfo;
	BFilePanel				*_panelImport;
	BFilePanel				*_panelExport;*/
	BMenuField				*_delay;
	// acces to be_app
	CounterApp		*_app;
	
public:
	BackupSettingView(BRect);
	virtual ~BackupSettingView(void);
	virtual void MessageReceived(BMessage* msg);
	virtual void AttachedToWindow(void);

private:
	void Refresh();
};

#endif